﻿local E = AleaUI
local CBF = E:Module("ClassBars")

local class1, class = UnitClass("player")
if class ~= "DRUID" then return end

local w, h = 50, 10
local maxw, maxh = 200, 10
local LUNAR_POWER = SPELL_POWER_LUNAR_POWER or 8

local color = { 0, 238/255, 1, 1  }

local function ComboBar()

	local f = CreateFrame("Frame", nil, E.UIParent)
	f:SetSize(maxw, maxh)
	E:Mover(f, "eclipseFrame", 200, 10)

	f.eventlist = {
		["UNIT_POWER_FREQUENT"] 	 = "player",
		["PLAYER_ENTERING_WORLD"]	= '',
		["UPDATE_SHAPESHIFT_FORM"]	= '',
		["PLAYER_TALENT_UPDATE"]	= '',
	}
	
	local o = CreateFrame("StatusBar", nil, f)
	o:SetFrameLevel(f:GetFrameLevel()+1)
	o:SetSize(maxw, maxh)
	o:SetStatusBarTexture([[Interface\Buttons\WHITE8x8]])
	o:SetPoint("LEFT", f, "LEFT", 0, 0)
	o:SetStatusBarColor(color[1]*0.8,color[2]*0.8,color[3]*0.8, 1)
	o:SetMinMaxValues(0, 100)
	
	o.art = CreateFrame("Frame", nil, o)
	o.art:SetFrameLevel(o:GetFrameLevel()-1)
	o.art:SetBackdrop({
	  bgFile = [[Interface\Buttons\WHITE8x8]], 
	  edgeFile = [[Interface\Buttons\WHITE8x8]], 
	  edgeSize = 1, 
	})
	o.art:SetBackdropColor(color[1]*0.2,color[2]*0.2,color[3]*0.2, 1)
	o.art:SetBackdropBorderColor(0,0,0,1)
	o.art:SetPoint('TOPLEFT', o, 'TOPLEFT', -1, 1)
	o.art:SetPoint('BOTTOMRIGHT', o, 'BOTTOMRIGHT', 1, -1)
	
	f.bar = o
	
	
	function f:UNIT_POWER_FREQUENT(event, unit)	
		if unit ~= "player" then return end
		
		local power = UnitPower("player", LUNAR_POWER );
		local maxPower = UnitPowerMax("player", LUNAR_POWER );
		
		f.bar:SetMinMaxValues(0, maxPower)
		f.bar:SetValue(power)
	end

	function f:PLAYER_ENTERING_WORLD()
		local form  = GetShapeshiftFormID();
		
		if form == MOONKIN_FORM then
			self:Show()
		else
			self:Hide()
		end
	end
	
	f.UPDATE_SHAPESHIFT_FORM = f.PLAYER_ENTERING_WORLD
	f.PLAYER_TALENT_UPDATE = f.PLAYER_ENTERING_WORLD
	
	f.Update = function(self)
		self:UNIT_POWER_FREQUENT(_, "player")
	end
	
	E.GUI.args.unitframes.args.classBars.args.unlock = {
		name = "Разблокировать",
		order = 2,
		type = "execute",
		set = function(self, value)
			E:UnlockMover("eclipseFrame") 
		end,
		get = function(self)end
	}
	
	return f
end



CBF:AddClassBar(class, 1, ComboBar)