﻿local E = AleaUI
local CBF = E:Module("ClassBars")

local class1, class = UnitClass("player")
if class ~= "DEATHKNIGHT" then return end

local w, h = 50, 10
local maxw, maxh = 200, 10

local NUM_RUNES = 6

local color = { 
	[1] = { 181/255, 0, 0, 1},
	[2] = { 81/255, 179/255, 72/255, 1 },
	[3] = { 0, 181/255, 181/255, 1},
	[4] = { 184/255, 104/255, 209/255, 1 },
 }

local runesRegen = function(self, elapsed)
	for i=1, 6 do
		local start, duration, runeReady = GetRuneCooldown(i);
		local runeType = 4

		self.bars[i]:SetMinMaxValues(start, start+duration)
		self.bars[i]:SetValue(GetTime())
		
		local alpha = 1
		
		if not runeReady then --or ( GetTime() < start+duration ) then
			alpha = 0.5
		end
		
		self.bars[i]:SetStatusBarColor(color[runeType][1]*alpha, color[runeType][2]*alpha, color[runeType][3]*alpha, color[runeType][4])
	end
end

local function DK_Runes()

	local f = CreateFrame("Frame", nil, E.UIParent)
	E:Mover(f, "runesFrame", 200, 10)
	f.bars = {}
	f.eventlist = {
	--	["RUNE_POWER_UPDATE"]		= "",
	--	["RUNE_TYPE_UPDATE"]		= "",
		}

	f:SetScript("OnUpdate", runesRegen)
	
	for i=1, NUM_RUNES do
		f:SetSize(maxw, 10)
		
		local o = CreateFrame("StatusBar", nil, f)
		o:SetFrameLevel(f:GetFrameLevel()+1)
		o:SetSize(maxw/NUM_RUNES-1, 10)
		o:SetStatusBarTexture([[Interface\Buttons\WHITE8x8]])
		o:SetPoint("LEFT", f, "LEFT", (maxw/NUM_RUNES)*(i-1), 0)
		o:SetStatusBarColor(1,1,1,0.5)
		o:SetMinMaxValues(0,1)
		
		o.art = CreateFrame("Frame", nil, o)
		o.art:SetFrameLevel(o:GetFrameLevel()-1)
		o.art:SetBackdrop({
		  bgFile = [[Interface\Buttons\WHITE8x8]], 
		  edgeFile = [[Interface\Buttons\WHITE8x8]], 
		  edgeSize = 1, 
		})
		o.art:SetBackdropColor(1*0.2,1*0.2,1*0.2, 1)
		o.art:SetBackdropBorderColor(0,0,0,1)
		o.art:SetPoint('TOPLEFT', o, 'TOPLEFT', -1, 1)
		o.art:SetPoint('BOTTOMRIGHT', o, 'BOTTOMRIGHT', 1, -1)

		f.bars[i] = o
	end
	
	function f:RUNE_POWER_UPDATE(runeIndex, isEnergize)
	end

	--f.RUNE_TYPE_UPDATE = f.RUNE_POWER_UPDATE

	E.GUI.args.unitframes.args.classBars.args.unlock = {
		name = "Разблокировать",
		order = 2,
		type = "execute",
		set = function(self, value)
			E:UnlockMover("runesFrame") 
		end,
		get = function(self)end
	}
	
	return f
end



CBF:AddClassBar(class, 1, DK_Runes)
CBF:AddClassBar(class, 2, DK_Runes)
CBF:AddClassBar(class, 3, DK_Runes)