local Skins = AleaUI:Module("Skins")
local _G = _G

local default_background_color = Skins.default_background_color
local default_border_color = Skins.default_border_color
local default_font = Skins.default_font
local default_texture = Skins.default_texture

local default_button_background = Skins.default_button_background
local default_button_border 	= Skins.default_button_border
local default_border_color_dark = Skins.default_border_color_dark

local varName = 'spellbook'
AleaUI.default_settings.skins[varName] = true

local function Skin_SpellBook()
	
	if not AleaUI.db.skins.enableAll then return end
	if not AleaUI.db.skins[varName] then return end

	SpellBookFrameTutorialButton:Kill()
	Skins.ThemeIconButton(SpellBookPrevPageButton)
	Skins.ThemeIconButton(SpellBookNextPageButton)
	
	Skins.MassKillTexture('SpellBookFrame')	
		
	Skins.ThemeBackdrop('SpellBookFrame')

	Skins.ThemeFrameRing('SpellBookFrame')
	for i=1, 4 do
		Skins.ThemeTab('SpellBookFrameTabButton'..i)
	end
	
	_G['PrimaryProfession1Rank']:SetFont(default_font, Skins.default_font_size, 'NONE')
	_G['PrimaryProfession2Rank']:SetFont(default_font, Skins.default_font_size, 'NONE')
	
	Skins.ThemeStatusBar('PrimaryProfession1StatusBar')
	Skins.ThemeStatusBar('PrimaryProfession2StatusBar')
	
	Skins.ThemeSpellButton('PrimaryProfession1SpellButtonBottom')
	Skins.ThemeSpellButton('PrimaryProfession1SpellButtonTop')
	Skins.ThemeSpellButton('PrimaryProfession2SpellButtonBottom')
	Skins.ThemeSpellButton('PrimaryProfession2SpellButtonTop')
	
	
	_G['SecondaryProfession1Rank']:SetFont(default_font, Skins.default_font_size, 'NONE')
	_G['SecondaryProfession2Rank']:SetFont(default_font, Skins.default_font_size, 'NONE')
	_G['SecondaryProfession3Rank']:SetFont(default_font, Skins.default_font_size, 'NONE')
	_G['SecondaryProfession4Rank']:SetFont(default_font, Skins.default_font_size, 'NONE')
	
	Skins.ThemeStatusBar('SecondaryProfession1StatusBar')
	Skins.ThemeStatusBar('SecondaryProfession2StatusBar')
	Skins.ThemeStatusBar('SecondaryProfession3StatusBar')
	Skins.ThemeStatusBar('SecondaryProfession4StatusBar')
	
	Skins.ThemeSpellButton('SecondaryProfession1SpellButtonLeft')
	Skins.ThemeSpellButton('SecondaryProfession1SpellButtonRight')
	Skins.ThemeSpellButton('SecondaryProfession2SpellButtonLeft')
	Skins.ThemeSpellButton('SecondaryProfession2SpellButtonRight')
	Skins.ThemeSpellButton('SecondaryProfession3SpellButtonLeft')
	Skins.ThemeSpellButton('SecondaryProfession3SpellButtonRight')
	Skins.ThemeSpellButton('SecondaryProfession4SpellButtonLeft')
	Skins.ThemeSpellButton('SecondaryProfession4SpellButtonRight')
	
	for i=1, 12 do		
		_G['SpellButton'..i..'SpellName']:SetFont(default_font, Skins.default_font_size, 'NONE')
		_G['SpellButton'..i..'SubSpellName']:SetFont(default_font, Skins.default_font_size, 'NONE')	
	end
	
	local function SkinTab(tab)
		tab:DisableDrawLayer('BACKGROUND')
		tab:GetNormalTexture():SetTexCoord(unpack(AleaUI.media.texCoord))
		tab:GetNormalTexture():SetSize(20, 20)
	
		tab.pushed = true;
		
		local checked = tab:GetCheckedTexture()
		local step = 0.06
		checked:SetTexCoord(step, 1-step, step, 1-step)
		
		Skins.ThemeBackdrop(tab)

		local point, relatedTo, point2, x, y = tab:GetPoint()
		tab:SetPoint(point, relatedTo, point2, 1, y)
	end

	--Skill Line Tabs
	for i=1, MAX_SKILLLINE_TABS do
		local tab = _G["SpellBookSkillLineTab"..i]
		_G["SpellBookSkillLineTab"..i.."Flash"]:Kill()
		SkinTab(tab)
	end
	
	local function SkinSkillLine()
		for i=1, MAX_SKILLLINE_TABS do
			local tab = _G["SpellBookSkillLineTab"..i]
			local _, _, _, _, isGuild = GetSpellTabInfo(i)
			if isGuild then
				tab:GetNormalTexture():SetInside()
				tab:GetNormalTexture():SetTexCoord(unpack(AleaUI.media.texCoord))
			end
		end
	end
	hooksecurefunc("SpellBookFrame_UpdateSkillLineTabs", SkinSkillLine)
end

AleaUI:OnInit2(Skin_SpellBook)